from __future__ import annotations
from enum import StrEnum
from pydantic import BaseModel, Field
from typing import Optional, Union
from maleo_core.models.base.transfers.results.general import BaseGeneralResults

class MaleoSecuritySecretGeneralTransfers:
    class DataTypes(StrEnum):
        BYTES = "bytes"
        STRING = "string"

    class Base(BaseModel):
        type:MaleoSecuritySecretGeneralTransfers.DataTypes = Field("string", description="Returned data type")
        name:str = Field(..., description="Secret's name")

    class GetParameters(Base):
        version:str = Field("latest", description="Secret's version. Default to 'latest'")

    class CreateParameters(Base):
        data:str = Field(..., description="Secret's data")

    class Results(Base):
        data:str = Field(..., description="Secret's data")

    Fail = BaseGeneralResults.Fail

    class SingleData(BaseGeneralResults.SingleData):
        data:Optional[MaleoSecuritySecretGeneralTransfers.Results]